//
//  Transaction.h
//  Hipster iPad
//
//  Created by Jiva DeVoe on 9/30/10.
//  Copyright 2010 Random Ideas, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>

#define INSERT_XACTION @"INSERT_XACTION"
#define DELETE_XACTION @"DELETE_XACTION"
#define UPDATE_XACTION @"UPDATE_XACTION"
#define EXPIRED_XACTION @"EXPIRED_XACTION" // this is an object which should not be deleted from the device, but which is no longer on the server and should not be resent.

@interface WHITransaction : NSObject <NSCoding>
{
    NSDate *date;
    NSString *type;
    NSManagedObject *obj;
    NSString *objGuid;
    NSString *objType;
    NSDictionary *jsonData;
    BOOL replayableTransaction;
}
@property BOOL replayableTransaction;
@property (strong, nonatomic) NSString * objGuid;
@property (strong, nonatomic) NSManagedObject * obj;
@property (strong, nonatomic) NSDate * date;
@property (strong, nonatomic) NSString *type;
@property (strong, nonatomic) NSString * objType;
@property (strong, nonatomic) NSManagedObjectContext *ctx;

+(id)transactionFromJSONDictionary:(NSDictionary *)inDict inContext:(NSManagedObjectContext *)inCtx;
+(id)transactionOfType:(NSString *)inType forObject:(NSManagedObject *)inObj;
+(id)deleteTransactionForObjectOfType:(NSString *)inObjType withGuid:(NSString *)inGuid inContext:(NSManagedObjectContext *)inCtx;

-(id)initWithType:(NSString *)inType forObject:(NSManagedObject *)inObj;
-(void)replayIntoMOC:(NSManagedObjectContext *)inCtx;
-(void)replayRelationshipsIntoMOC:(NSManagedObjectContext *)inCtx;

@end
